OleAutoObj ecpsGetProposalsQuery(Module m, Object targetObj, string attrList, bool alsoIncludeAppliedCRs, OleAutoObj obj_csApiLib, OleAutoObj obj_csUser)
{
        /* //these parameters are passed on instead of repeating the method calls
	OleAutoObj obj_csApiLib = null
	OleAutoObj obj_csUser = null
   	obj_csApiLib = get_csApiLib(obj_csUser)
	\*/
	OleAutoObj csQueryData = null
	current =m
	if !null obj_csUser then 
	{
		string query = null
		if null targetObj then
		{
			if alsoIncludeAppliedCRs then
			{
				query = buildRcrForModuleQuery(m)
			}
			else
			{
				query = buildRcrForModuleQuery(m) " and crstatus!='" getCSINTConfigurationSettings(CSINT_CONFIG_RCP_APPLIED_STATE, m) "'"
			}
		}
		else
		{
			if alsoIncludeAppliedCRs then
			{
				query = buildRcrForObjectQuery(targetObj)
			}
			else
			{
				query = buildRcrForObjectQuery(targetObj) " and crstatus!='" getCSINTConfigurationSettings(CSINT_CONFIG_RCP_APPLIED_STATE, m) "'"
			}
		}

		csintDebug_ "query " query "\n"
		csintDebug_ "attrs " attrList "\n"
		//csQueryData = do_csApiLib_QueryStringData(obj_csApiLib, obj_csUser, "Data_Report_CR", query, attrList)
		csQueryData = do_csApiLib_QueryStringData(obj_csApiLib, obj_csUser, "Data_Report_rcr_and_rc", query, attrList)
	}
	
	return csQueryData
}

string getActionObjectDoorsId(Buffer &orcBuffer)
{
	string doorsID = ""

	int sectionPos = 0
	string sectionData = ""
	Buffer sectionBuffer = create

	// ---------------------------
	// get rc attrs section
	// ---------------------------
	Skip rcAttrs = createString
	if (getValueBetweenTags(sectionPos, orcBuffer, H_X_RC_ATTRS, sectionData)) then
	{
		sectionBuffer += sectionData

		// looping for each attribute
		string attrName = null
		string attrValue = null
		Buffer valueBuffer = create
		int attrPos = 0
		while (getValueBetweenTags(attrPos, sectionBuffer, xTAG_KEY, attrName))
		{
			setempty valueBuffer
			valueBuffer = attrName
			unescapeXML(valueBuffer)
			attrName = stringOf valueBuffer
			if attrName == CSINT_RCM_RC_DOORSID then
			{
				if (getValueBetweenTags(attrPos, sectionBuffer, H_X_VALUE, attrValue)) then
				{
					setempty valueBuffer
					valueBuffer = attrValue
					unescapeXML(valueBuffer)
					attrValue = stringOf valueBuffer

					doorsID = attrValue
				}
				break
			}
		}
		delete valueBuffer
	}
	delete sectionBuffer

	return doorsID
}

//------------------------------------------------
// Update Function invoked manually by DOORS user
//------------------------------------------------
void updateCPstatusAndRefreshStatusAttribute(string viewName, Object targetObj)
{
      
	OleAutoObj csQueryData = null
	OleAutoObj csObjectVector = null
	string errMsg = ""
	Module m = current Module
	string modID  = uniqueID(item (fullName (m)))
	string dbID = getDoorsDB_ID()
	string mrcDoorsID = "req" modID

	int numRecords      = 0
	int index           = 0
	//int numDoorsAttrs   = 0

	string doorsid      = ""
	string crid         = ""
	string crinstance   = ""
	string crsummary    = ""
	string crstatus     = ""
	string crpriority   = ""
	string crchangetype = ""
	string proposaltype = ""

	string attrList = ECPS_DEFAULT_CACHE_QUERY_ATTRS

	OleAutoObj obj_csApiLib = null
	OleAutoObj obj_csUser = null
	obj_csApiLib = get_csApiLib(obj_csUser)

	bool alsoIncludeAppliedCRs = getAttrListFromViewConfig(viewName, attrList)

	csQueryData = ecpsGetProposalsQuery(m, targetObj, attrList, alsoIncludeAppliedCRs, obj_csApiLib, obj_csUser)

	if (!confFileExists("csint_" modID, confSystem)) then confMkdir("csint_" modID, confSystem)
	if (viewName == ECPS_STATUS_VIEW) then
	{
		if (!confFileExists("csint_" modID "/" RCR_STATUS_CACHE_DIR, confSystem)) then confMkdir("csint_" modID "/" RCR_STATUS_CACHE_DIR, confSystem)
	}
	else if (viewName == ECPS_ATTRS_VIEW) then
	{
		if (!confFileExists("csint_" modID "/" RCR_ATTRS_CACHE_DIR, confSystem)) then confMkdir("csint_" modID "/" RCR_ATTRS_CACHE_DIR, confSystem)
	}

	
	if !null obj_csUser then
	{
		bool needCleanCache = true
		Skip openedCacheFiles = createString
		if !null csQueryData then
		{
			errMsg = oleGet(csQueryData, "DataSize", numRecords)
         
			if null errMsg then
			{
				//if numRecords == 0 then errMsg = "There were no Proposals Found"

				// for each RCR
				for (index = 0; index < numRecords; index++)
				{
					csObjectVector = getObjectVector(csQueryData, index, errMsg)
					crid         = getRecordField(csObjectVector, ECPS_PROBLEM_NUM,  errMsg)
					csintDebug_("RCR " crid)
					string rcrName = getRecordField(csObjectVector, "name",      errMsg)
					//doorsid      = getRecordField(csObjectVector, ECPS_DOORSID,      errMsg)
					crinstance   = getRecordField(csObjectVector, ECPS_SUBSYSTEM,    errMsg)
					Buffer b_line = create

					b_line += XMLstartTag(xTAG_CP)
					b_line += XMLstartTag(xTAG_ID)
					b_line += crid
					b_line += XMLendTag(xTAG_ID)
					b_line += xTAG_NEWLINE

					b_line += XMLstartTag(xTAG_ATTRS)
					b_line += xTAG_NEWLINE
					int iSizeAttr = get_int_from_OleAutoObj(csObjectVector, "DataSize")
					int iAttr

					// for each attribute of a RCR
					for (iAttr=0; iAttr<iSizeAttr; iAttr+=1)
					{
						OleAutoObj obj_csObjectData = get_indexed_OleAutoObj_from_OleAutoObj(csObjectVector, "DataObject", iAttr)
						string cr_attr = get_string_from_OleAutoObj(obj_csObjectData, "Name")
						string cr_attr_type = get_string_from_OleAutoObj(obj_csObjectData, "Type")
						string cr_attr_value = get_string_from_OleAutoObj(obj_csObjectData, "Value")
						if (cr_attr_type == "CCM_DATE") then cr_attr_value = get_string_from_OleAutoObj(obj_csObjectData, "Date")

						b_line += XMLstartTag(xTAG_NAME)
						b_line += escapeXML(cr_attr)
						b_line += XMLendTag(xTAG_NAME)
						b_line += XMLstartTag(xTAG_VALUE)
						b_line += escapeXML(cr_attr_value)
						b_line += XMLendTag(xTAG_VALUE)
						b_line += xTAG_NEWLINE
					}

					//for each proposed attribute requested
					//if (numDoorsAttrs > 0)
					//{
					//	string doorsAttr = null
					//	OleAutoObj csApi = null
					//	OleAutoObj csUser = null
					//	csApi = get_csApiLib(csUser)
					//	string cvid = getNewAttrsCVID(csApi, csUser, crid, crinstance)
					//	for doorsAttr in DOORSAttrs do
					//	{
					//		int len = length(doorsAttr)
					//		b_line += XMLstartTag(xTAG_NAME)
					//		b_line += escapeXML(doorsAttr)
					//		b_line += XMLendTag(xTAG_NAME)
					//		b_line += XMLstartTag(xTAG_VALUE)	
					//		b_line += getDOORSProposedAttrValue(csApi,csUser,cvid,doorsAttr[0:len-2],"VALUE")
					//		b_line += XMLendTag(xTAG_VALUE)
					//		b_line += xTAG_NEWLINE
					//	}
					//}
					b_line += XMLendTag(xTAG_ATTRS)
					b_line += xTAG_NEWLINE

					b_line += XMLendTag(xTAG_CP)
					b_line += xTAG_NEWLINE
					b_line += xTAG_NEWLINE

					string aLine = stringOf b_line
					
					delete b_line

					Skip doorsIDSkip = createString
					//string rcNewQuery = "is_dynamic_attrs_new_of('" crinstance "/problem/" rcrName "/1') and doorsID match 'req" modID "*' and " CSINT_RCM_RC_DOORS_DB_ID "='" dbID "'"
					//csintDebug_ ("Query for dynamic attrs new is: " rcNewQuery "")
					//OleAutoObj queryResults = do_csApiLib_QueryStringData(obj_csApiLib, obj_csUser, "", rcNewQuery, CSINT_RC_NEW_ATTRS)
					OleAutoObj queryResults = get_OleAutoObj_from_OleAutoObj(csObjectVector, "ChildData")
					if (!null queryResults) then
					{
						int numDynamicNew = get_int_from_OleAutoObj(queryResults, "DataSize")
						csintDebug_ ("The number of RCs returned is " numDynamicNew "")

						// for each rc new
						int index
						for (index = 0; index < numDynamicNew; index++)
						{
							string errMsg
							OleAutoObj rcVector = getObjectVector(queryResults, index, errMsg)
							string doorsID = getRecordField(rcVector, CSINT_RCM_RC_DOORSID,    errMsg)
							string changeType = getRecordField(rcVector, CSINT_RCM_RC_CHANGETYPE,    errMsg)
							csintDebug_("\t" doorsID "\t" changeType)
							if changeType == CSINT_RCM_CHANGETYPE_RECORDING_MODULE_EDIT then
							{
								if doorsID == mrcDoorsID then
								{
									csintDebug_("\tThis is a MRC .....................................................for this module.")

									Buffer mAssociatedRCs = create
									mAssociatedRCs += getRecordField(rcVector, "doorsAssociatedRCs", errMsg)
									csintDebug_("\tdoorsAssociatedRCs=" stringOf(mAssociatedRCs))

									int mPosition = 0
									string orcDoorsID = ""
									while (getValueBetweenTags(mPosition, mAssociatedRCs, "ID", orcDoorsID))
									{
										if !null orcDoorsID then put(doorsIDSkip, orcDoorsID, orcDoorsID)
									}

									delete mAssociatedRCs
								}
								else csintDebug_("\tSkip this mrc because it is not in this module.")
							}
//							else
//							{
//								string mId = null
//								string oId = null
//								ecpsSplitID(doorsID, mId, oId)
//								if mId == modID then put(doorsIDSkip, doorsID, doorsID)
//								else csintDebug_("\tSkip this rc because it is not in this module.")
//							}
						}
					}

					for doorsid in doorsIDSkip do
					{
						string cachefileName = "csint_" modID "/" RCR_STATUS_CACHE_DIR "/" doorsid
						if (viewName == ECPS_ATTRS_VIEW) then cachefileName = "csint_" modID "/" RCR_ATTRS_CACHE_DIR "/" doorsid
						if (!null cachefileName) then
						{
							ConfStream f 

							if find(openedCacheFiles, doorsid) then
							{
								f = confAppend(cachefileName ,confSystem)
							}
							else
							{
								put(openedCacheFiles, doorsid, doorsid)
								f = confWrite(cachefileName ,confSystem)
							}
							f << aLine << "\n"
							close(f)
						}
					}
					delete doorsIDSkip
				}
			}
			else
			{
				needCleanCache = false
			}
			cleanupQueryData(csQueryData)
		}
		else
		{
			// csQueryData is null
			//errMsg = "There were no Proposals Found"
		}

		// need to clean all cache files which are not updated
		if needCleanCache then
		{
			Skip cacheFilesToBeCleaned = createString
			csintDebug_("clean all cache files which are not updated:")
			
			string dirName = "csint_" modID "/" RCR_STATUS_CACHE_DIR
			if (viewName == ECPS_ATTRS_VIEW) then dirName =  "csint_" modID "/" RCR_ATTRS_CACHE_DIR
			string fName
			for fName in confDirectory(dirName, confSystem) do
			{
				if ((fName!=".")&&(fName!="..")) then
				{
					if !find(openedCacheFiles, fName) then
					{
						csintDebug_("\t" fName " with is not updated.")
						put(cacheFilesToBeCleaned, fName, fName)
					}
					else
					{
						csintDebug_("\t" fName " with doors is ------------------------------ OK.")
					}
				}
			}

			for fName in cacheFilesToBeCleaned do
			{
				string cachefileName = dirName "/" fName
				confDeleteFile(cachefileName, confSystem)
			}

			delete cacheFilesToBeCleaned
		}

		if false then
		{
			Object everyObject = null
			for everyObject in entire(m) do
			{
				if !null targetObj then
				{
					if everyObject != targetObj then continue
				}

				doorsid = ""
				if canRead(everyObject) then doorsid = csintGetObjectUniqueID(everyObject)
				if !find(openedCacheFiles, doorsid) then
				{
					string cachefileName =  "csint_" modID "/" RCR_STATUS_CACHE_DIR "/" doorsid
					
					if (viewName == ECPS_ATTRS_VIEW) then cachefileName =  "csint_" modID "/" RCR_ATTRS_CACHE_DIR "/" doorsid
					if (!null cachefileName) then
					{
						if confFileExists(cachefileName, confSystem) then
						{
							confDeleteFile(cachefileName, confSystem)
						}
					}
				}
			}
		}

		delete openedCacheFiles
	}
	
	if !null errMsg then ack errMsg
        {
		
		ecpsRefreshDXLAttributes(m) 
	}
	if (viewName == ECPS_STATUS_VIEW) then
	{
		if currentView(m) != ECPS_STATUS_VIEW then load(m, view(ECPS_STATUS_VIEW))
	}
	refresh m
}
//------------------------------------------------
// Update Function invoked manually by DOORS user
//------------------------------------------------
void updateCPstatusAndRefreshStatusAttribute(string viewName, Object targetObj, Module mod)
{
     
	OleAutoObj csQueryData = null
	OleAutoObj csObjectVector = null
	string errMsg = ""
	Module m = mod
	string modID  = uniqueID(item (fullName (m)))
	// print "modID " modID  "\n"
	string dbID = getDoorsDB_ID()
	string mrcDoorsID = "req" modID

	int numRecords      = 0
	int index           = 0
	//int numDoorsAttrs   = 0

	string doorsid      = ""
	string crid         = ""
	string crinstance   = ""
	string crsummary    = ""
	string crstatus     = ""
	string crpriority   = ""
	string crchangetype = ""
	string proposaltype = ""

	string attrList = ECPS_DEFAULT_CACHE_QUERY_ATTRS
	OleAutoObj obj_csApiLib = null
	OleAutoObj obj_csUser = null
	obj_csApiLib = get_csApiLib(obj_csUser)

	bool alsoIncludeAppliedCRs = getAttrListFromViewConfig(viewName, attrList)

	csQueryData = ecpsGetProposalsQuery(m, targetObj, attrList, alsoIncludeAppliedCRs, obj_csApiLib, obj_csUser)

	if (!confFileExists("csint_" modID, confSystem)) then confMkdir("csint_" modID, confSystem)
	if (viewName == ECPS_STATUS_VIEW) then
	{
		if (!confFileExists("csint_" modID "/" RCR_STATUS_CACHE_DIR, confSystem)) then confMkdir("csint_" modID "/" RCR_STATUS_CACHE_DIR, confSystem)
	}
	else if (viewName == ECPS_ATTRS_VIEW) then
	{
		if (!confFileExists("csint_" modID "/" RCR_ATTRS_CACHE_DIR, confSystem)) then confMkdir("csint_" modID "/" RCR_ATTRS_CACHE_DIR, confSystem)
	}

	
	if !null obj_csUser then
	{
		bool needCleanCache = true
		Skip openedCacheFiles = createString
		if !null csQueryData then
		{
			errMsg = oleGet(csQueryData, "DataSize", numRecords)
         
			if null errMsg then
			{
				//if numRecords == 0 then errMsg = "There were no Proposals Found"

				// for each RCR
				for (index = 0; index < numRecords; index++)
				{
					csObjectVector = getObjectVector(csQueryData, index, errMsg)
					crid         = getRecordField(csObjectVector, ECPS_PROBLEM_NUM,  errMsg)
					csintDebug_("RCR " crid)
					string rcrName = getRecordField(csObjectVector, "name",      errMsg)
					//doorsid      = getRecordField(csObjectVector, ECPS_DOORSID,      errMsg)
					crinstance   = getRecordField(csObjectVector, ECPS_SUBSYSTEM,    errMsg)
					Buffer b_line = create

					b_line += XMLstartTag(xTAG_CP)
					b_line += XMLstartTag(xTAG_ID)
					b_line += crid
					b_line += XMLendTag(xTAG_ID)
					b_line += xTAG_NEWLINE

					b_line += XMLstartTag(xTAG_ATTRS)
					b_line += xTAG_NEWLINE
					int iSizeAttr = get_int_from_OleAutoObj(csObjectVector, "DataSize")
					int iAttr

					// for each attribute of a RCR
					for (iAttr=0; iAttr<iSizeAttr; iAttr+=1)
					{
						OleAutoObj obj_csObjectData = get_indexed_OleAutoObj_from_OleAutoObj(csObjectVector, "DataObject", iAttr)
						string cr_attr = get_string_from_OleAutoObj(obj_csObjectData, "Name")
						string cr_attr_type = get_string_from_OleAutoObj(obj_csObjectData, "Type")
						string cr_attr_value = get_string_from_OleAutoObj(obj_csObjectData, "Value")
						if (cr_attr_type == "CCM_DATE") then cr_attr_value = get_string_from_OleAutoObj(obj_csObjectData, "Date")

						b_line += XMLstartTag(xTAG_NAME)
						b_line += escapeXML(cr_attr)
						b_line += XMLendTag(xTAG_NAME)
						b_line += XMLstartTag(xTAG_VALUE)
						b_line += escapeXML(cr_attr_value)
						b_line += XMLendTag(xTAG_VALUE)
						b_line += xTAG_NEWLINE
					}

					//for each proposed attribute requested
					//if (numDoorsAttrs > 0)
					//{
					//	string doorsAttr = null
					//	OleAutoObj csApi = null
					//	OleAutoObj csUser = null
					//	csApi = get_csApiLib(csUser)
					//	string cvid = getNewAttrsCVID(csApi, csUser, crid, crinstance)
					//	for doorsAttr in DOORSAttrs do
					//	{
					//		int len = length(doorsAttr)
					//		b_line += XMLstartTag(xTAG_NAME)
					//		b_line += escapeXML(doorsAttr)
					//		b_line += XMLendTag(xTAG_NAME)
					//		b_line += XMLstartTag(xTAG_VALUE)	
					//		b_line += getDOORSProposedAttrValue(csApi,csUser,cvid,doorsAttr[0:len-2],"VALUE")
					//		b_line += XMLendTag(xTAG_VALUE)
					//		b_line += xTAG_NEWLINE
					//	}
					//}
					b_line += XMLendTag(xTAG_ATTRS)
					b_line += xTAG_NEWLINE

					b_line += XMLendTag(xTAG_CP)
					b_line += xTAG_NEWLINE
					b_line += xTAG_NEWLINE

					string aLine = stringOf b_line
					delete b_line

					Skip doorsIDSkip = createString
					 
					//string rcNewQuery = "is_dynamic_attrs_new_of('" crinstance "/problem/" rcrName "/1') and doorsID match 'req" modID "*' and " CSINT_RCM_RC_DOORS_DB_ID "='" dbID "'"
					//csintDebug_ ("Query for dynamic attrs new is: " rcNewQuery "")
					//OleAutoObj queryResults = do_csApiLib_QueryStringData(obj_csApiLib, obj_csUser, "", rcNewQuery, CSINT_RC_NEW_ATTRS)
					OleAutoObj queryResults = get_OleAutoObj_from_OleAutoObj(csObjectVector, "ChildData")
					if (!null queryResults) then
					{
						int numDynamicNew = get_int_from_OleAutoObj(queryResults, "DataSize")
						csintDebug_ ("The number of RCs returned is " numDynamicNew "")

						// for each rc new
						int index
						for (index = 0; index < numDynamicNew; index++)
						{
							string errMsg
							OleAutoObj rcVector = getObjectVector(queryResults, index, errMsg)
							string doorsID = getRecordField(rcVector, CSINT_RCM_RC_DOORSID,    errMsg)
							string changeType = getRecordField(rcVector, CSINT_RCM_RC_CHANGETYPE,    errMsg)
							csintDebug_("\t" doorsID "\t" changeType)
							if changeType == CSINT_RCM_CHANGETYPE_RECORDING_MODULE_EDIT then
							{
								if doorsID == mrcDoorsID then
								{
									csintDebug_("\tThis is a MRC .....................................................for this module.")

									Buffer mAssociatedRCs = create
									mAssociatedRCs += getRecordField(rcVector, "doorsAssociatedRCs", errMsg)
									csintDebug_("\tdoorsAssociatedRCs=" stringOf(mAssociatedRCs))

									int mPosition = 0
									string orcDoorsID = ""
									while (getValueBetweenTags(mPosition, mAssociatedRCs, "ID", orcDoorsID))
									{
										if !null orcDoorsID then put(doorsIDSkip, orcDoorsID, orcDoorsID)
									}

									delete mAssociatedRCs
								}
								else csintDebug_("\tSkip this mrc because it is not in this module.")
							}
//							else
//							{
//								string mId = null
//								string oId = null
//								ecpsSplitID(doorsID, mId, oId)
//								if mId == modID then put(doorsIDSkip, doorsID, doorsID)
//								else csintDebug_("\tSkip this rc because it is not in this module.")
//							}
						}
					}

					for doorsid in doorsIDSkip do
					{
					 
						string cachefileName = "csint_" modID "/" RCR_STATUS_CACHE_DIR "/" doorsid
						if (viewName == ECPS_ATTRS_VIEW) then cachefileName = "csint_" modID "/" RCR_ATTRS_CACHE_DIR "/" doorsid
						if (!null cachefileName) then
						{
							ConfStream f 

							if find(openedCacheFiles, doorsid) then
							{
								f = confAppend(cachefileName ,confSystem)
							}
							else
							{
								put(openedCacheFiles, doorsid, doorsid)
								f = confWrite(cachefileName ,confSystem)
							}
							f << aLine << "\n"
							close(f)
						}
					}
					delete doorsIDSkip
				}
			}
			else
			{
				needCleanCache = false
			}
			cleanupQueryData(csQueryData)
			
		}
		else
		{
			// csQueryData is null
			//errMsg = "There were no Proposals Found"
		}

		// need to clean all cache files which are not updated
		if needCleanCache then
		{
			Skip cacheFilesToBeCleaned = createString
			csintDebug_("clean all cache files which are not updated:")
			string dirName = "csint_" modID "/" RCR_STATUS_CACHE_DIR
			if (viewName == ECPS_ATTRS_VIEW) then dirName =  "csint_" modID "/" RCR_ATTRS_CACHE_DIR
			string fName
			for fName in confDirectory(dirName, confSystem) do
			{
				if ((fName!=".")&&(fName!="..")) then
				{
					if !find(openedCacheFiles, fName) then
					{
						csintDebug_("\t" fName " with is not updated.")
						put(cacheFilesToBeCleaned, fName, fName)
					}
					else
					{
						csintDebug_("\t" fName " with doors is ------------------------------ OK.")
					}
				}
			}

			for fName in cacheFilesToBeCleaned do
			{
				string cachefileName = dirName "/" fName
				confDeleteFile(cachefileName, confSystem)
			}

			delete cacheFilesToBeCleaned
		}

		if false then
		{
			
			Object everyObject = null
			for everyObject in entire(m) do
			{
				if !null targetObj then
				{
					if everyObject != targetObj then continue
				}

				doorsid = ""
				if canRead(everyObject) then doorsid = csintGetObjectUniqueID(everyObject)
				if !find(openedCacheFiles, doorsid) then
				{
					string cachefileName =  "csint_" modID "/" RCR_STATUS_CACHE_DIR "/" doorsid
					if (viewName == ECPS_ATTRS_VIEW) then cachefileName =  "csint_" modID "/" RCR_ATTRS_CACHE_DIR "/" doorsid
					if (!null cachefileName) then
					{
						if confFileExists(cachefileName, confSystem) then
						{
							confDeleteFile(cachefileName, confSystem)
						}
					}
				}
			}
		}

		delete openedCacheFiles
	}

	if !null errMsg then ack errMsg
	 
	ecpsRefreshDXLAttributes(m) 
	
	if (viewName == ECPS_STATUS_VIEW) then
	{
		if currentView(m) != ECPS_STATUS_VIEW then load(m, view(ECPS_STATUS_VIEW))
	}
	refresh m
	
}

void updateCPstatusAndRefreshStatusAttribute(string viewName)
{
	updateCPstatusAndRefreshStatusAttribute(viewName, null)
}
