/**********************************************************************
*
*	DXL:		relate_to_crs.inc
*	Instance:		1
*	Description:	Synergy/DOORS Integration
*			Relates objects to their source CRs
*	%created_by:	bsteele %
*	%date_created:	 Wednesday, June 01, 2005 2:13:52 PM %
*
*   Copyright (c) 2003 Telelogic AB
**********************************************************************/

#include <addins/synergy/utils/lib.inc>
#include <addins/synergy/utils/csint_util.inc>
#include <addins/synergy/ecps2csapi/ecps_csapi.inc>


void relateObjToCR(DB theDB)
{
	Object o
	Module m = current
	OleAutoObj com
	ecpsLogin(com)
	OleAutoObj obj_csUser = getUserObject(com)
	OleAutoObj obj_csApiLib = getWrapperCSApiObject(obj_csUser)
	int count = 0
	int loopCount = 0
	for o in m do
	{
		string aCR = o.CSINT_DOORS_OBJECT_ATTR_SOURCE_CR
		if ((!null aCR) && (aCR != ""))
		{
			count++
		}
	}
	progressStart(theDB, "Create Traceability Progress", "Processing CRs...", count)

	for o in m do
	{
		string aCR = o.CSINT_DOORS_OBJECT_ATTR_SOURCE_CR
		if ((!null aCR) && (aCR != ""))
		{
			progressStep ++loopCount
			if (progressCancelled)
			{
				progressStop
				return
			}
			string loopCountString = loopCount ""
			string countString = count ""
			progressMessage "Processing Change Request " loopCountString " of " countString
			Buffer b_query = create
			b_query += "problem_number='"
			b_query += aCR
			b_query += "'"
			queryString = stringOf b_query
			delete b_query
			OleAutoObj obj_csQueryData = do_csApiLib_QueryStringData(obj_csApiLib, obj_csUser, "", queryString, "problem_number")
			
			// if not exist, go to the next object in the module
			if (null obj_csQueryData)
			{
				continue
			}
			else
			{
				// retrieve associated CRs
				string object_ID = csintGetObjectUniqueID(o)

				string object_cvid = get_Requirement_cvid(obj_csApiLib, obj_csUser, object_ID)
				if (null object_cvid)
				{
					// need to create requirement object first.
					//
					object_cvid = create_Requirement(obj_csApiLib, obj_csUser, object_ID)
				}

				OleAutoObj obj_csQueryData4CRs = get_associated_source_CRs(obj_csApiLib, obj_csUser, object_ID, "", "problem_number")
				if (!null obj_csQueryData4CRs) then 
				{
					//it is already associated, skip it
					continue
				}
				else
				{
					create_cr_req_relation(com, aCR, object_cvid, CSINT_DOORS_SOURCE_CR_RELATION)
				}
			}
		}
	}
	progressStop
}
