
string getCSWebTypeforDoorsType(string dType)
{
	if (dType == "attrDate") return "CCM_DATE"
	else if (dType == "Integer") return "CCM_NUMBER"
	else if (dType == "Real") return "CCM_NUMBER"
	else if (dType == "Text") return "ALL"
	else if (dType == "String") return "CCM_STRING"
	else if (dType == "Username") return "CCM_USER"
	else if (dType == "Enumeration") return "CCM_LISTBOX"
	else return "ALL"
}
//=================================================================
//
//=================================================================
bool isTextAttr(Module m, string attrName)
{
	bool result = false

	AttrDef ad = find (m,attrName)
	if !null ad then 
	{
		AttrType adt = ad.type
		string typeName = adt.type ""
		if (typeName=="String" or typeName=="Text") then 
		{ 
			result = true
		}
	}

	return result   
}



//=================================================================
//
//=================================================================
bool isEnumAttr(Module m, string attrName)
{
	bool result = false

	AttrDef ad = find (m,attrName)
	if !null ad then 
	{
		AttrType adt = ad.type
		string typeName = adt.type ""
		
		if (typeName=="Enumeration") then result = true
	}

	return result   
}


//=================================================================
//
//=================================================================
bool isMultiValue (Module m,string attrName) 
{
	AttrDef ad = find (m,attrName)
	bool result = false

	if !null ad then result = ad.multi

	return result   
}




bool setCSAttributes(OleAutoObj obj_csApiLib, obj_csUser)
{
	string result = null
	Module  m = current
	Skip theAttrs = createString
	int size = loadIRDisplayMappingList(m, theAttrs)
	
	string attrLabel
	string ccmType

	
	OleAutoObj attrArray = oleCreateAutoObject "cslib.csObjectVector"
	string errMsg = oleMethod(attrArray, "Create")
	if (!null errMsg)
	{
		csintDebug_("Failed to create data structure : " errMsg "\n")
		return false
	}

	//These are the attributes we are going to create
        int i = 0 
	int mysize = 0
	int myfinal = 0

	for attrLabel in theAttrs do
	{
	    
	       string  doorsattr = (string key theAttrs)
	   
		AttrDef ad = find(m, doorsattr)

		if (null ad)
		{ // This attribute doesn't seem to exist
			continue
		}
		i++

	}
	myfinal = i + 7

        olePut(attrArray, "DataSize", myfinal) 

	for attrLabel in theAttrs do
	{
	    
	       string  doorsattr = (string key theAttrs)
	   
		AttrDef ad = find(m, doorsattr)

		if (null ad)
		{ // This attribute doesn't seem to exist
			continue
		}
	 
	 AttrType adt = ad.type
	 string typeName = adt.type ""
	 string doors
	 ccmType= getCSWebTypeforDoorsType(typeName)
	
	OleAutoObj oAttr = createCSAttrObj(attrLabel, ccmType, doorsattr)
	if (!addCSObjectDatatoArray(attrArray, oAttr, mysize))
	{
		return false
	}
          mysize++
        }
	
	
	//Add Last Modification Date to the array
	OleAutoObj oModTime = createCSAttrObj("doors_modify_time", "CCM_NUMBER", "DOORS Object Last Modified On")
	
	if (!addCSObjectDatatoArray(attrArray, oModTime, mysize))
	{
		return false
	}
        mysize++
	//Add full path to DOORS object in human readable format
	OleAutoObj oDoorsPath = createCSAttrObj("doors_object_path", "CCM_STRING", "DOORS ID")
	if (!addCSObjectDatatoArray(attrArray, oDoorsPath, mysize))
	{
		return false
	}
	mysize++
	//Numeric object ID used by requirements change management
	OleAutoObj oDoorsID = createCSAttrObj("doorsID", "CCM_STRING", "DOORS Object ID")
	if (!addCSObjectDatatoArray(attrArray, oDoorsID, mysize))
	{ //
		return false
	}
        mysize++
	//Database ID used by requirements change management
	OleAutoObj oDoorsDBID = createCSAttrObj("doorsDBID", "CCM_STRING", "DOORS Database ID")
	if (!addCSObjectDatatoArray(attrArray, oDoorsDBID, mysize))
	{ //
		return false
	}
       mysize++
	OleAutoObj oDoorsChangeType = createCSAttrObj("doorsChangeType", "CCM_STRING", "Change Type")
	if (!addCSObjectDatatoArray(attrArray, oDoorsChangeType, mysize))
	{ //
		return false
	}
       mysize++

	OleAutoObj oDoorsIsApplied = createCSAttrObj("doorsIsApplied", "CCM_TOGGLE", "Applied to DOORS")
	if (!addCSObjectDatatoArray(attrArray, oDoorsIsApplied, mysize))
	{ //
		return false
	}
       mysize++
	OleAutoObj oLastModifiedBy = createCSAttrObj("doorsLastModifiedBy", "CCM_USER", "Last Modified By")
	if (!addCSObjectDatatoArray(attrArray, oLastModifiedBy, mysize))
	{ //
		return false
	}
	mysize++
            
       // olePut(attrArray, "DataSize",i) // originally 9  need to put the size first
	OleAutoArgs oArgs = create
	put (oArgs, obj_csUser)
	put (oArgs, "DOORSCS")
	put (oArgs, attrArray)
	errMsg = oleMethod(obj_csApiLib, "SetCSAttributes", oArgs, result)
	delete oArgs
	if (!null errMsg)
	{
		//print "Unable to create attributes in " CSNAME " : " errMsg "\n"
		return false
	}

	return true

}

void push_Obj_Data_to_CS(OleAutoObj obj_csApiLib, obj_csUser, Object obj, string cvid, int cmModTime, Module mdl)
{
	csintDebug_("\t\tpush_Obj_Data_to_CS():")
	string attrLabel
	string ccmType
	Module m = mdl
	Skip theAttrs = createString
	int attrsize = loadIRDisplayMappingList(m, theAttrs)

	

	if (null obj)
	{ 
		csintDebug_("\t\tobj is null")
		OleAutoObj attrArray = oleCreateAutoObject "cslib.csObjectVector"
		string errMsg = oleMethod(attrArray, "Create")
		if (!null errMsg)
		{
			csintDebug_("\t\tFailed to create data structure : " errMsg)
			return
		}	
		
		//There are two attributes we are going to create
		olePut(attrArray, "DataSize", 1)

		//Add the object identifier to the array
		OleAutoObj oPathAttr = createCMAttrObj("doors_object_path", "string", "*DELETED*")
		if (!addCSObjectDatatoArray(attrArray, oPathAttr, 0))
		{
			csintDebug_("\t\tFailed to add doors_object_path to data structure")
			return false
		}

		//Call CS with the constructed array
		OleAutoArgs oArgs = create
		put (oArgs, obj_csUser)
		put (oArgs, cvid)
		put (oArgs, attrArray)
		errMsg = oleMethod(obj_csApiLib, "GetModifyObjectAttributes", oArgs)
		delete oArgs

		if (!null errMsg)
		{
			csintDebug_("\t\tUnable to modify attributes in " CSNAME " : " errMsg)
		}
		else
		{
			csintDebug_("\t\tPush obj data to CS succeed.")
		}
	}
	else
	{
		if ((canRead obj."Object Text") && (canRead obj."Object Heading"))
		{
			if (null cvid)
			{
				csintDebug_("\t\tcvid is null, skip push")
				// There isn't a CM object representing this requirement yet.
				// There won't be one until somebody submits a CR against this requirement.
				return
			}

			Date tmp = lastModifiedTime(obj)
			int oModTime = intOf(tmp)

			if (oModTime <= cmModTime)
			{
				csintDebug_("\t\tObj in DOORS has not been updated since last sync on this object, skip push")
				csintDebug_("Object modify time is " tmp "")
				csintDebug_("Last sync time is " dateOf(cmModTime) "")
				//This object has not been updated in DOORS, no need to push data to CS
				return
			}

			string oText = obj."Object Text"
			string oHeading = obj."Object Heading"
			string oPath = getObjectFullname(obj)

			//Create an array to hold the attributes
			OleAutoObj attrArray = oleCreateAutoObject "cslib.csObjectVector"
			string errMsg = oleMethod(attrArray, "Create")
			if (!null errMsg)
			{
				csintDebug_("\t\tFailed to create data structure : " errMsg)
				return
			}	
			
			 AttrType adt 
			 string typeName 
			 string doors
			
			if( attrsize > 0) then
			{
                        string attrLabel
			int i = 0 
			int csArraycount = 0
			int finalsize =0
			//Need to put the data size first  so count the  attrs.
			for attrLabel in theAttrs do
			{
			    
			       string  doorsattr = (string key theAttrs)
			       AttrDef ad = find(m, doorsattr)

				if (null ad)
				{ // This attribute doesn't seem to exist
					continue
				}
				else if(!ad.object)
				{
					continue
				}
                                else
				{
					i++
				}
			 
			}

			finalsize = i + 3
			olePut(attrArray, "DataSize", finalsize)// change this to my arraysize

			for attrLabel in theAttrs do
			{
			    
			       string  doorsattr = (string key theAttrs)
			       AttrDef ad = find(m, doorsattr)

				if (null ad)
				{ // This attribute doesn't seem to exist
					continue
				}
				if(!ad.object)
				{
					continue
				}
			 
			  adt = ad.type
			 typeName = adt.type ""
			 ccmType= getCSWebTypeforDoorsType(typeName)
			 oText = obj.doorsattr
			
			OleAutoObj oPathAttr = createCMAttrObj(attrLabel, ccmType, escapeXML(oText))
			if (!addCSObjectDatatoArray(attrArray, oPathAttr, csArraycount))
			{
				csintDebug_("\t\tFailed to add doors_object_path to data structure")
				return false
			}
			 
			  csArraycount++
			}
			
			//Add the current time so we can avoid re-syncing if the requirement hasn't changed
			//These 3 are required 
			int now = intOf today
			OleAutoObj oModTimeAttr = createCMIntAttrObj("doors_modify_time", now)
			if (!addCSObjectDatatoArray(attrArray, oModTimeAttr, csArraycount))
			{
				csintDebug_("\t\tFailed to add doors_modify_time to data structure")
				return false
			}
			 csArraycount++
			//Add the object identifier to the array
			OleAutoObj oPathAttr = createCMAttrObj("doors_object_path", "string", escapeXML(oPath))
			if (!addCSObjectDatatoArray(attrArray, oPathAttr,  csArraycount))
			{
				csintDebug_("\t\tFailed to add doors_object_path to data structure")
				return false
			}
			csArraycount++
			string urlToObject = getURL(obj)
			OleAutoObj oUrl = createCMAttrObj("doorsURL", "string", escapeXML(urlToObject))
			if (!addCSObjectDatatoArray(attrArray, oUrl, csArraycount))
			{
				csintDebug_("\t\tFailed to add doorsURL to data structure")
				return false
			}
			csArraycount++
                       // olePut(attrArray, "DataSize", csArraycount)//  need to put first
			OleAutoArgs oArgs = create
			put (oArgs, obj_csUser)
			put (oArgs, cvid)
			put (oArgs, attrArray)
			errMsg = oleMethod(obj_csApiLib, "GetCreateObjectAttributes", oArgs)
			delete oArgs

			if (!null errMsg)
			{
				csintDebug_("\t\tUnable to create attributes in " CSNAME " : " errMsg)
			}
			else
			{
				csintDebug_("\t\tPush obj data to CS succeed.")
			}
		}
		else
		{	// Keep the original
			//There are two attributes we are going to create		
			//Add Object Heading to the array
			
			OleAutoObj oHeadingAttr = createCMAttrObj("doors_heading", "string", escapeXML(oHeading))
			if (!addCSObjectDatatoArray(attrArray, oHeadingAttr,0))
			{
				csintDebug_("\t\tFailed to add doors_heading to data structure")
				return false
			}

			//Add Object Text to the array
			OleAutoObj oTextAttr = createCMAttrObj("doors_object_text", "text", escapeXML(oText))
			if (!addCSObjectDatatoArray(attrArray, oTextAttr,1))
			{
				csintDebug_("\t\tFailed to add doors_object_text to data structure")
				return false
			}
                        

			//Add the current time so we can avoid re-syncing if the requirement hasn't changed
			//These 3 are required 
			int now = intOf today
			OleAutoObj oModTimeAttr = createCMIntAttrObj("doors_modify_time", now)
			if (!addCSObjectDatatoArray(attrArray, oModTimeAttr, 2))
			{
				csintDebug_("\t\tFailed to add doors_modify_time to data structure")
				return false
			}
			
			//Add the object identifier to the array
			OleAutoObj oPathAttr = createCMAttrObj("doors_object_path", "string", escapeXML(oPath))
			if (!addCSObjectDatatoArray(attrArray, oPathAttr,  3))
			{
				csintDebug_("\t\tFailed to add doors_object_path to data structure")
				return false
			}
			
			string urlToObject = getURL(obj)
			OleAutoObj oUrl = createCMAttrObj("doorsURL", "string", escapeXML(urlToObject))
			if (!addCSObjectDatatoArray(attrArray, oUrl, 4))
			{
				csintDebug_("\t\tFailed to add doorsURL to data structure")
				return false
			}
			
                        olePut(attrArray, "DataSize", 5)// change this to my arraysize
			//Call CS with the constructed array
			OleAutoArgs oArgs = create
			put (oArgs, obj_csUser)
			put (oArgs, cvid)
			put (oArgs, attrArray)
			errMsg = oleMethod(obj_csApiLib, "GetCreateObjectAttributes", oArgs)
			delete oArgs

			if (!null errMsg)
			{
				csintDebug_("\t\tUnable to create attributes in " CSNAME " : " errMsg)
			}
			else
			{
				csintDebug_("\t\tPush obj data to CS succeed.")
			}



		}

		}
		else
		{
			csintDebug_("\t\tNo privilege to read this obj data in DOORS")
		}
	}
}

void push_Obj_Data_to_CS(OleAutoObj obj_csApiLib, obj_csUser, Object obj, Module mdl)
{
	string reqname = csintGetObjectUniqueID(obj)
	string cvid = null
	int cmModTime
	Module m = mdl
	if (!get_Requirement_cvid_and_modTime(obj_csApiLib, obj_csUser, reqname, cvid, cmModTime))
	{
		//Failed to identify the requirement
		csintDebug_("\t\tCan not find the CV for " reqname ", skip push data to CS")
		return
	}
	push_Obj_Data_to_CS(obj_csApiLib, obj_csUser, obj, cvid, cmModTime, m)
}
