<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html"/>

<xsl:template match="/">
	<html>
		<head>
			<title>Activity Report</title>
		</head>
		<body>
			<xsl:apply-templates select="//reqmt" />
		</body>
	</html>
</xsl:template>

<xsl:template match="reqmt">
	<p>
	<h3>Requirement <xsl:value-of select="@object_id"/>: <xsl:value-of select="@heading"/></h3>
	<i><xsl:value-of select="@text"/></i>
	<UL type="square">
	<xsl:apply-templates select=".//change_request"/>
	</UL>
	</p>
</xsl:template>

<xsl:template match="change_request">
	<li>
	<b><i>Change Request <xsl:value-of select="@problem_number"/>: <xsl:value-of select="@problem_synopsis"/></i></b><BR/>
	<table cols="2">
		<tr>
			<TD width="10%">Type:</TD>
			<TD><xsl:value-of select="@request_type"/></TD>
		</tr>
		<tr>
			<TD>Status:</TD>
			<TD><xsl:value-of select="@crstatus"/></TD>
		</tr>
		<tr>
			<TD>Release:</TD>
			<TD><xsl:value-of select="@release"/></TD>
		</tr>
		<tr>
			<TD>Resolver:</TD>
			<TD><xsl:value-of select="@resolver"/></TD>
		</tr>
		<tr>
			<TD>Severity:</TD>
			<TD><xsl:value-of select="@severity"/></TD>
		</tr>
		<tr>
			<TD>Description:</TD>
			<TD><xsl:value-of select="@problem_description"/></TD>
		</tr>
	</table>
	<ul>
	<xsl:apply-templates select=".//task"/>
	</ul>
	</li>
</xsl:template>

<xsl:template match="task">
	<li>
	<b>Task <xsl:value-of select="@task_number"/>: <xsl:value-of select="@task_synopsis"/></b><BR/>
	<table cols="2">
		<tr>
			<TD width="10%">Status:</TD>
			<TD><xsl:value-of select="@status"/></TD>
		</tr>
		<tr>
			<TD>Release:</TD>
			<TD><xsl:value-of select="@release"/></TD>
		</tr>
		<tr>
			<TD>Resolver:</TD>
			<TD><xsl:value-of select="@resolver"/></TD>
		</tr>
	</table>
	<BLOCKQUOTE>
		<B>Added/Modified Files:</B><BR/>
		<TABLE cols="3" WIDTH="40%" BORDER="1">
			<xsl:apply-templates select=".//file"/>
		</TABLE>
	</BLOCKQUOTE>
	<BLOCKQUOTE>
		<B>Baselines:</B><BR/>
		<TABLE cols="3" WIDTH="40%" BORDER="1">
			<xsl:apply-templates select=".//baseline"/>
		</TABLE>
	</BLOCKQUOTE>
	</li>
</xsl:template>

<xsl:template match="baseline">
	<TR>
		<TD><xsl:value-of select="@displayname"/></TD>
		<TD><xsl:value-of select="@status"/></TD>
		<TD><xsl:value-of select="@release"/></TD>
	</TR>
</xsl:template>

<xsl:template match="file">
	<tr>
		<TD><xsl:value-of select="@displayname"/></TD>
		<TD><xsl:value-of select="@owner"/></TD>
		<TD><xsl:value-of select="@status"/></TD>
	</tr>
</xsl:template>

</xsl:stylesheet>
