DB rcrImpact
DBE affectedObjectListDBE
int numberOfObjects
bool rcrImpactCancelled = false
string objectIDList = ""

string getObjectIDList()
{
	return objectIDList
}


void onRcrImpactClose(DB theDB)
{
	rcrImpactCancelled = true
	release theDB
}

void onRcrImpactOK(DB theDB)
{
	Buffer b = create
	bool foundOne = false
	int i

	for(i = 0; i < numberOfObjects ; i++ )
	{ //
		if (getCheck(affectedObjectListDBE, i))
		{
			foundOne = true
			string oVal = get(affectedObjectListDBE, i)
			b += "|" oVal
		}
	}

	if (!foundOne)
	{ //
		ack "You must select at least one object"
		delete b
		return
	}

	string oIdList = stringOf(b)
	objectIDList = oIdList[1:] //Strip off the initial | character
	csintDebug_ ("List of selected objects is " objectIDList)
	delete b
	rcrImpactCancelled = false
	release theDB
}

//---------------------------------------
//---------------------------------------
//parse module unique id and object abs num from object unique id
//example id "000000229-15"

void splitID (string uid, &modid ,string &objid){
     if matches ("(.*)_(.*)",uid) then {
        modid = uid[match 1]
        objid = uid[match 2]
     }else{   
        modid = null
        objid = uid
     }//end if
      
}//end



void populateAffectedObjectList(string rcrID, rcrName, rcrSubsystem)
{
	// login to cs
	string errMsg
	OleAutoObj obj_csUser = null
	OleAutoObj obj_csApiLib = get_csApiLib(obj_csUser)
	Object curObj = current

	csintDebug_ ("populateAffectedObjectList ===================")
	if (!null obj_csUser) then
	{
		string rcNewQuery = "is_dynamic_attrs_new_of('" rcrSubsystem "/problem/" rcrName "/1')"
		csintDebug_ ("Query for dynamic attrs new is: " rcNewQuery "")

		OleAutoObj queryResults = do_csApiLib_QueryStringData(obj_csApiLib, obj_csUser, "Data_Report_dynamic_attrs_new", rcNewQuery, "cvid|name|version|cvtype|subsystem|doorsDBID|doorsID|doorsChangeType|doorsAssociatedRCs")
		if (!null queryResults) then
		{
			int numDynamicNew = get_int_from_OleAutoObj(queryResults, "DataSize")
			csintDebug_ ("The number of dynamic_attrs_new returned is " numDynamicNew "")

			// for each rc new
			int insertCounter = 0
			int index;
			for (index = 0; index < numDynamicNew; index++)
			{
				OleAutoObj rcVector = getObjectVector(queryResults, index, errMsg)
				string cvidNew = getRecordField(rcVector, "cvid",  errMsg)
				string rcDoorsID = getRecordField(rcVector, "doorsID",  errMsg)
				string shortenedID = rcDoorsID[3:]  //Strip the req from the front
				string mId = ""
				string oId = ""
				string oText = ""
				ecpsSplitID(rcDoorsID, mId, oId)
				Module m = current
				Item i = item fullName m
				string currentModId = uniqueID i
				csintDebug_ ("Current module ID is " currentModId)
				csintDebug_ ("RC module ID is " mId)
				if (mId == currentModId)
				{
					csintDebug_("The current module matches the module for this RC")
					string associatedRCsString = getRecordField(rcVector, "doorsAssociatedRCs",  errMsg)
					csintDebug_("Associated RCs = " associatedRCsString)
					Buffer mAssociatedRCs = create
					mAssociatedRCs += associatedRCsString
					int mPosition = 0
					string orcDoorsID = ""
					while (getValueBetweenTags(mPosition, mAssociatedRCs, "ID", orcDoorsID))
					{
						if !null orcDoorsID then
						{
							string orcObjId = ""
							string orcModuleId = ""
							ecpsSplitID(orcDoorsID, orcModuleId, orcObjId)

							Object o = object(intOf(orcObjId))
							if (!null o)
							{ //
								oText = o."Object Text"
								insert(affectedObjectListDBE, insertCounter, orcObjId)
								set(affectedObjectListDBE, insertCounter, 1, oText)
								string curObjAbsNo = curObj."Absolute Number"
								if (curObjAbsNo == orcObjId)
								{ //
									setCheck(affectedObjectListDBE, insertCounter, true)
								}
								insertCounter++
							}
						}
					}
					delete mAssociatedRCs
				}
			}
			numberOfObjects = insertCounter
			cleanupQueryData(queryResults)
		}
	}
}


void rcr_impact_dialog(string rcrID, selectedCrName, selectedCrSubsystem)
{
	string emptyList[] = {}
	rcrImpact = create("Select Requirements to Implement", styleCentered)

	apply(rcrImpact, "OK", onRcrImpactOK)
	//ok(selectRCP, "OK", onOK)
	close(rcrImpact, true, onRcrImpactClose)
	affectedObjectListDBE = listView(rcrImpact,listViewOptionCheckboxes|listViewOptionMultiselect,2,18, emptyList)

	realize rcrImpact
	insertColumn(affectedObjectListDBE, 0, "ID", 100, iconNone)
	insertColumn(affectedObjectListDBE, 1, "Object Text", 500, iconNone)
	setSortColumn(affectedObjectListDBE, 0)

	populateAffectedObjectList(rcrID, selectedCrName, selectedCrSubsystem)
	setCenteredSize(rcrImpact, 600, 445)
	block rcrImpact
}
